%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Xout = AIHT(Mz, b, Omega,  ell, Xinit, params)

n = size(Xinit, 1);
t = abs(Omega(Xinit));
p = length(t(:));
%q = quantile(t(:), ell/p);
%LambdaE = find(t<=q);
OLE = zeros(2*n, n-1);
%OLE(LambdaE) = 1;
%[CompC, numComps] = CosupportComponents(OLE);

mu = params.gradient_step;
Xout = Xinit;
Xprev = Xout;

for iter = 1:params.max_iteration
  iter
  MXout = fft2(Xout);
  MXout(Mz) = 0;
  Xout = Xout + mu * (b - ifft2(MXout));
  t = abs(Omega(Xout));
  q = quantile(t(:), ell/p);
  if (iter > 2 && q < params.cosupport_threshold_check) || iter > 50
    q = min(params.cosupport_threshold, 2*q);
    LambdaE = find(t<=q);
    disp(['***********' num2str(length(LambdaE)-ell)]);
    ell = min(length(LambdaE), ell+params.cosparsity_adjustment_step);
    q = quantile(t(:), ell/p);
  end
  LambdaE = find(t<=q);
  OLE(:) = 0;
  OLE(LambdaE) = 1;
  [CompC, numComps] = CosupportComponents(OLE);
  Xout = CosparseProjection(CompC, numComps, Xout);
  
  disp(['relative change=', num2str(norm(Xout(:)-Xprev(:))/norm(Xprev(:)))]);
  Xprev = Xout;
  
  figure(9);
  imshow(real(Xout));
end