%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function x = FDSynthesis(w, n)

t = reshape(w, 2*n, n-1);
x = zeros(n, n);
x(:, 2:end) = t(1:n, :);
x(:, 1:(end-1)) = x(:, 1:(end-1)) - t(1:n, :);
x(2:end, :) = x(2:end, :) + t((n+1):end, :).';
x(1:(end-1), :) = x(1:(end-1), :) - t((n+1):end, :).';
x = x(:);
