%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Loc = SamplingLocationsL1Magic(N, L)

% returns sampling locations
% corresponding to Fourier coefficients of N x N image
% along L radial lines.

thc = linspace(0, pi-pi/L, L);
%thc = linspace(pi/(2*L), pi-pi/(2*L), L);

Loc = zeros(N);

% full mask
for ll = 1:L

        if ((thc(ll) <= pi/4) | (thc(ll) > 3*pi/4))
                yr = round(tan(thc(ll))*(-N/2+1:N/2-1))+N/2+1;
        for nn = 1:N-1
        Loc(yr(nn),nn+1) = 1;
      end
  else
                xc = round(cot(thc(ll))*(-N/2+1:N/2-1))+N/2+1;
                for nn = 1:N-1
                        Loc(nn+1,xc(nn)) = 1;
                end
        end

end

Loc = ifftshift(Loc);
