%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n = 256;
numLines = 35;
ell = 2*n*(n-1) - 50*n;
%ell = 31246;

X = phantom('Modified Shepp-Logan', n);

G = [X(:,2:end)-X(:,1:end-1); (X(2:end,:)-X(1:end-1,:))'];

params = struct();
params.inner_iteration = 0;
params.gradient_step = 0.5;

Loc = SamplingLocations(n, numLines);
Mz = (Loc == 0);

b = fft2(X);
b(Mz) = 0;
b = ifft2(b);


Xinit = b;
Xinit = zeros(size(X));

params.max_iteration = 30;
params.cosupport_threshold = 2e-2;
params.cosupport_threshold_check = 5e-3;
params.cosparsity_adjustment_step = 500;
Omega = @(t) FDAnalysis(t, n);
s = tic();
XoutAIHT = AIHT(Mz, b, Omega, ell, Xinit, params);
elapsedICP = toc(s);


disp(['relative errors: AIHT=', num2str(norm(XoutAIHT(:)-X(:))/norm(X(:)))]);