%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [x_est,Lambda_est]=Analysis_GAP(y,Omega,M,k)

% This function runs the GAP algorithm

Omega_est = Omega; 

% Note: Lambda_est is not necessary for the computation of x_est
% This is used for diagnostic purposes
Lambda_est = 1:size(Omega, 1);

L=size(Omega,1); % number of analysis rows not treated
alpha=0.001;
delta=1;
x_prev=0;
delta_min = 1e-5;
if size(M, 1) > 0.9*size(M,2)
    delta_min = 1e-10;
end

while delta>delta_min && L>k 
    x_est=pinv([alpha*Omega_est; M])*[zeros(L,1); y];
    proj=abs(Omega_est*x_est);
    index=find(proj~=max(proj));
    Lambda_est = Lambda_est(index);
    Omega_est=Omega_est(index,:); 
    L=size(Omega_est, 1);
    delta=norm(x_prev - x_est)/norm(x_est);
    x_prev=x_est;
end;
x_est=pinv([Omega_est; M])*[zeros(size(Omega_est,1),1); y];

return;
