%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sigma = 1.2;
delta_interval = 0.05;
rho_interval = 0.05;
delta = delta_interval:delta_interval:1;
rho = rho_interval:rho_interval:1;
d = 120;
N = 50;
na = 10;%number of algorithms checked
nd = length(delta);
nr = length(rho);

RecoveryRate = zeros(nd, nr, na);
RelativeError = ones(nd, nr, na);
for i = 1:(nd*nr)
    dfile = sprintf('OUTPUTDIR\\analysisAlgos%d.mat', i);
    load(dfile)
    [itd, itr] = ind2sub([nd, nr], i);
    for ita = 1:na
        RecoveryRate(itd, itr, ita) = rec_rate(ita);
        RelativeError(itd, itr, ita) = rel_err(ita);
    end
end

clear i, itd, itr
save output-merged.mat
