%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function r = PlotPhaseDiagram(delta, rho, Data, pngfname)

imagesc(delta, rho, Data');
set(gca, 'YDir', 'normal');
xlabel('$\delta$', 'Interpreter', 'latex', 'Fontsize', 40);
ylabel('$\rho$ \ ', 'Interpreter', 'latex', 'Fontsize', 40, 'Rotation', 0);
if strcmp(pngfname(end-2:end), 'eps')
    colormap(gray);
    print('-deps', pngfname)
else
    colormap(gray);
    print('-dpng', pngfname)
end

