%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function mu = gradient_descent_step_static(xprev, descent, y, M, Omega, LambdaEst, cosparsity)

persistent mu_const
if isempty(mu_const)
    d = size(M, 2);
    p = size(Omega, 1);
    num_sample = 200;
    mu_low = 1e30;
    mu_high = 0.0;
    for j = 1:num_sample
        cosupp = randperm(p);
        cosupp = sort(cosupp(1:cosparsity));
        OL = Omega(cosupp, :);
        cosvec = randn(d, 1);
        cosvec = cosvec - pinv(OL) * OL * cosvec;
        tmu = norm(cosvec, 2)^2 / norm(M*cosvec, 2)^2;
        %if tmu > mu_high
        %    mu_high = tmu;
        %end
        if tmu < mu_low
            mu_low = tmu;
        end
    end
    %mu_const = (5*mu_low + mu_high)/6;
    mu_const = mu_low/2.5;
end

mu = mu_const;
return;
