%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0                                    
%     
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose.                                        
%                                                                                                                                                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function mu = gradient_descent_step_theoretical_adaptive2(xprev, descent, y, M, Omega, LambdaEst, cosparsity)

p = size(Omega,1);
[~, tempind] = sort(abs(Omega(LambdaEst,:)*descent));
DescentLambdaEst = sort(tempind(1:(end+cosparsity - p)));
if ~isempty(DescentLambdaEst)
    OL = Omega(DescentLambdaEst, :);
    proj_descent = descent - pinv(OL) * OL * descent;
else 
    proj_descent = descent;
end
mu = norm(proj_descent, 2)^2 / norm(M*proj_descent, 2)^2;
return;