%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0
%
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
%
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can
% redistribute it and/or modify it under the terms of this licence, for
% personal and non-commercial use and research purpose.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [xhat, C] = projection_optimal_wrt_M(xhat_grad, OL, M, y, x0)

[nr, nc] = size(OL);
%OLPerp = eye(nc) - pinv(OL)*OL;  the following condition implements this projection.
if (size(OL,1) < size(OL,2))
    OLPerp = eye(nc) - OL'*pinv(OL*OL')*OL;
else
    OLPerp = eye(nc) - pinv(OL'*OL)*(OL'*OL);
end
xhat = pinv([OLPerp*M'*M; OL]) * [OLPerp*M'*y; zeros(nr, 1)];
if nargin >4
    xproj = xhat_grad - OLPerp*xhat_grad;
    C = norm(xhat - xproj).^2/norm(x0 - xhat_grad).^2;
end
return;
