%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Analysis Greedy Like Algorithms (AGLA)
% Version 1.0
%
% Copyright 2012 Raja Giryes, Sangnam Nam, Michael Elad, Remi Gribonval, and Mike. E. Davies
%
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can
% redistribute it and/or modify it under the terms of this licence, for
% personal and non-commercial use and research purpose.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [xhat, C] = projection_plain(xhat_grad, OL, M, y,x0)

%xhat = xhat_grad - pinv(OL) * OL * xhat_grad: the following condition implements this projection
if (size(OL,1) < size(OL,2))
    xhat = xhat_grad - OL'*pinv(OL*OL')*OL*xhat_grad;
else
    xhat = xhat_grad - pinv(OL'*OL)*(OL'*OL)*xhat_grad;
end
if nargin >4
    C = norm(xhat - xhat_grad).^2/norm(x0 - xhat_grad).^2;
end
return;
